## yade 1.05.0

=== CMakeLists.txt ===
# The YADE has the following parameters to configure:
#  INSTALL_PREFIX: path, where Yade will be installed (/usr/local by default)
#  LIBRARY_OUTPUT_PATH: path to install libraries (lib by default)
#  DEBUG: compile in debug-mode (OFF by default)
#  CMAKE_VERBOSE_MAKEFILE: output additional information during compiling (OFF by default)
#  SUFFIX: suffix, added after binary-names (version number by default)
#  NOSUFFIX: do not add a suffix after binary-name (OFF by default)
#  YADE_VERSION: explicitely set version number (is defined from git-directory by default)
#  ENABLE_GUI: enable GUI option (ON by default)
#  ENABLE_CGAL: enable CGAL option (ON by default)
#  ENABLE_VTK: enable VTK-export option (ON by default)
#  ENABLE_OPENMP: enable OpenMP-parallelizing option (ON by default)
#  ENABLE_GTS: enable GTS-option (ON by default)
#  ENABLE_GL2PS: enable GL2PS-option (ON by default)
#  ENABLE_LINSOLV: enable LINSOLV-option (ON by default)
#  ENABLE_PFVFLOW: enable PFVFLOW-option, FlowEngine (ON by default)
#  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
#  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default).


project(Yade C CXX)
cmake_minimum_required(VERSION 2.8)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cMake")

INCLUDE(FindPythonLibs)
INCLUDE(FindPythonInterp)
INCLUDE(FindOpenMP)
INCLUDE(FindQt4)
INCLUDE(FindVTK)
INCLUDE(FindPkgConfig)
INCLUDE(GetVersion)
INCLUDE(FindOpenGL)
INCLUDE(FindGTS)
INCLUDE(FindGL2PS)
INCLUDE(FindCGAL)
INCLUDE(FindNumPy)
INCLUDE(FindLoki)
INCLUDE(FindPythonModule)
INCLUDE(GNUInstallDirs)
#===========================================================
IF (CMAKE_CXX_FLAGS)
  #If flags are set, add only neccessary flags
  IF (DEBUG)
    SET(CMAKE_VERBOSE_MAKEFILE 1)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG")
  ELSE (DEBUG)
    SET(CMAKE_BUILD_TYPE Release)
    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -fPIC")
  ENDIF (DEBUG)
ELSE (CMAKE_CXX_FLAGS)
  #If flags are not set, add all useful flags
  IF (DEBUG)
    SET(CMAKE_VERBOSE_MAKEFILE 1)
    SET(CMAKE_BUILD_TYPE Debug)
    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
  ELSE (DEBUG)
    SET(CMAKE_BUILD_TYPE Release)
    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
  ENDIF (DEBUG)
ENDIF (CMAKE_CXX_FLAGS)
#===========================================================
# Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)

FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread date_time filesystem iostreams regex serialization system REQUIRED)
INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
# for checking purpose
MESSAGE("--   Boost_VERSION: " ${Boost_VERSION})
MESSAGE("--   Boost_LIB_VERSION: " ${Boost_LIB_VERSION})
MESSAGE("--   Boost_INCLUDE_DIRS: " ${Boost_INCLUDE_DIRS})
MESSAGE("--   Boost_LIBRARIES: " ${Boost_LIBRARIES})

#===========================================================
FIND_PACKAGE(NumPy REQUIRED)
  INCLUDE_DIRECTORIES(${NUMPY_INCLUDE_DIRS})

FIND_PACKAGE(Loki REQUIRED)
  INCLUDE_DIRECTORIES(${LOKI_INCLUDE_DIR})
FIND_PACKAGE(Eigen3 REQUIRED)
FIND_PACKAGE(BZip2 REQUIRED)
FIND_PACKAGE(ZLIB REQUIRED)
#===========================================================

SET(DEFAULT ON CACHE INTERNAL "Default value for enabled by default options")
SET(LINKLIBS "")
SET(CONFIGURED_FEATS "")
SET(DISABLED_FEATS "")

OPTION(ENABLE_VTK "Enable VTK" ${DEFAULT})
OPTION(ENABLE_OPENMP "Enable OpenMP" ${DEFAULT})
OPTION(ENABLE_GTS "Enable GTS" ${DEFAULT})
OPTION(ENABLE_GUI "Enable GUI" ${DEFAULT})
OPTION(ENABLE_CGAL "Enable CGAL" ${DEFAULT})
OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT})
OPTION(ENABLE_PFVFLOW "Enable flow engine (experimental)" ${DEFAULT})

#===========================================================
# Use Eigen3 by default
IF (EIGEN3_FOUND)
  INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
  MESSAGE(STATUS "Found Eigen3")
  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen3")
ENDIF(EIGEN3_FOUND)
#===========================================================
INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
#===========================================================
IF(ENABLE_VTK)
  FIND_PACKAGE(VTK COMPONENTS Common) 
  IF(VTK_FOUND)
    INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
    LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
    SET(features "${features} vtk")
    MESSAGE(STATUS "Found VTK")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
  ELSE(VTK_FOUND)
    MESSAGE(STATUS "VTK NOT found")
    SET(ENABLE_VTK OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
  ENDIF(VTK_FOUND)
ELSE(ENABLE_VTK)
  SET(DISABLED_FEATS "${DISABLED_FEATS} VTK")
ENDIF(ENABLE_VTK)
#===========================================================
IF(ENABLE_OPENMP)
  FIND_PACKAGE(OpenMP)
  IF(OPENMP_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP ${OpenMP_CXX_FLAGS}")
    MESSAGE(STATUS "Found OpenMP")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
    SET(features "${features} openmp")
  ELSE(OPENMP_FOUND)
    MESSAGE(STATUS "OpenMP NOT found")
    SET(ENABLE_OPENMP OFF)
    SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
  ENDIF(OPENMP_FOUND)
ELSE(ENABLE_OPENMP)
  SET(DISABLED_FEATS "${DISABLED_FEATS} OPENMP")
ENDIF(ENABLE_OPENMP)
#===========================================================
IF(ENABLE_GTS)
  FIND_PACKAGE(GTS)
  FIND_PACKAGE(glib2)
  IF(GTS_FOUND AND GLIB2_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GTS ${CMAKE_GTS_CXX_FLAGS}")
    SET(CMAKE_LD_FLAGS  "${CMAKE_LD_FLAGS} ${GTS_LIBRARIES}")
    INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIR})
    INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
    MESSAGE(STATUS "Found GTS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
    SET(features "${features} gts")
  ELSE(GTS_FOUND AND GLIB2_FOUND)
    MESSAGE(STATUS "GTS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
    SET(ENABLE_GTS OFF)
  ENDIF(GTS_FOUND AND GLIB2_FOUND)
ELSE(ENABLE_GTS)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
ENDIF(ENABLE_GTS)
#===========================================================
IF(ENABLE_GUI)
  FIND_PACKAGE(Qt4 COMPONENTS QtCore QtGui QtOpenGL)
  FIND_PACKAGE(OpenGL)
  FIND_PACKAGE(GLUT)
  FIND_PACKAGE(glib2)
  FIND_PACKAGE(QGLVIEWER)
  IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
    SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})
    SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
    SET(features "${features} qt4 opengl")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL")
    INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
    INCLUDE_DIRECTORIES(${QT_INCLUDES})
    
    MESSAGE(STATUS "Found GUI-LIBS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GUI")
  ELSE(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
    MESSAGE(STATUS "GUI-LIBS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GUI")
    SET(ENABLE_GUI OFF)
  ENDIF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
ELSE(ENABLE_GUI)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GUI")
ENDIF(ENABLE_GUI)
#===========================================================
# This one will automatically enable CGAL
IF(ENABLE_PFVFLOW)
  IF (NOT ENABLE_CGAL)
    MESSAGE(STATUS "PFVFLOW depends on CGAL, attempting to turn ENABLE_CGAL ON")
    SET(ENABLE_CGAL ON)
  ENDIF (NOT ENABLE_CGAL)
ENDIF(ENABLE_PFVFLOW)
#===========================================================
IF(ENABLE_CGAL)  
  INCLUDE(FindGMP)
  FIND_PACKAGE(CGAL)
  FIND_PACKAGE(GMP)
  IF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang"))) #Check for clang should be removed, when CGAL will be compilable by clang
    #INCLUDE_DIRECTORIES(${CGAL_INCLUDE_DIR})
    #INCLUDE_DIRECTORIES(${GMP_INCLUDE_DIR})
    #INCLUDE_DIRECTORIES(${GMPXX_INCLUDE_DIR})
    
    FILE(GLOB CGAL_SRC_LIB "lib/triangulation/*.cpp")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DYADE_CGAL")
    SET(LINKLIBS  "${LINKLIBS};${CGAL_LIBRARIES};${GMP_LIBRARIES};${GMPXX_LIBRARIES};")
    MESSAGE(STATUS "Found CGAL")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} CGAL")

    IF(ENABLE_PFVFLOW)
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFLOW_ENGINE")
      SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} PFVflow")
    ELSE(ENABLE_PFVFLOW)
      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
    ENDIF(ENABLE_PFVFLOW)

  ELSE(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
    MESSAGE(STATUS "CGAL NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
    SET(ENABLE_CGAL OFF)
    IF(ENABLE_PFVFLOW)
      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
      MESSAGE(STATUS "CGAL NOT found: PFVFLOW disabled")
    ENDIF(ENABLE_PFVFLOW)

  ENDIF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
ELSE(ENABLE_CGAL)
  SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
ENDIF(ENABLE_CGAL)
#===========================================================
IF(ENABLE_LINSOLV)
  FIND_PACKAGE(Cholmod)
  FIND_PACKAGE(OpenBlas)
  FIND_PACKAGE(Metis)
  IF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DLINSOLV -DFLOW_ENGINE")
    SET(LINKLIBS  "${LINKLIBS};${CHOLMOD_LIBRARIES};${AMD_LIBRARY};${CAMD_LIBRARY};${COLAMD_LIBRARY};${CCOLAMD_LIBRARY};${OPENBLAS_LIBRARY};${METIS_LIBRARY}")
    INCLUDE_DIRECTORIES(${METIS_INCLUDE_DIR} ${CHOLMOD_INCLUDE_DIR})
    MESSAGE(STATUS "Found Cholmod")
    MESSAGE(STATUS "Found OpenBlas")
    MESSAGE(STATUS "Found Metis")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} LinSolv")
  ELSE(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
    MESSAGE(STATUS "CHOLMOD NOT found, LINSOLV disabled")
    SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
    SET(ENABLE_LINSOLV OFF)
  ENDIF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
ELSE(ENABLE_LINSOLV)
  SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
ENDIF(ENABLE_LINSOLV)
#===============================================
IF(ENABLE_GL2PS)
  FIND_PACKAGE(GL2PS)
  IF(GL2PS_FOUND)
    INCLUDE_DIRECTORIES(${GL2PS_INCLUDE_DIR})
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GL2PS")
    SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
    MESSAGE(STATUS "Found GL2PS")
    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")
  ELSE(GL2PS_FOUND)
    MESSAGE(STATUS "GL2PS NOT found")
    SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
    SET(ENABLE_GL2PS OFF)
  ENDIF(GL2PS_FOUND)
ELSE(ENABLE_GL2PS)
  SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
ENDIF(ENABLE_GL2PS)

INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

#===========================================================

IF (NOT INSTALL_PREFIX)
 SET(CMAKE_INSTALL_PREFIX "/usr/local")
 MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
ELSE (NOT INSTALL_PREFIX)
	GET_FILENAME_COMPONENT(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX} ABSOLUTE)

=== debian/changelog ===
yade (1.05.0-2~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.
  * Remove python-gts, libmetis-dev and python-minieigen from Build-Depends.
  * Replace libqglviewer-dev by libqglviewer-qt4-dev.

 -- Anton Gladky <gladk@debian.org>  Tue, 03 Dec 2013 20:47:54 +0100

yade (1.05.0-2) unstable; urgency=low

  * [cf3f8d9] Pass -ftrack-macro-expansion=0 only if gcc>=4.8. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Wed, 30 Oct 2013 20:56:33 +0100

yade (1.05.0-1) unstable; urgency=low

  * [8448883] Imported Upstream version 1.05.0
  * [82b3047] Do not use clang explicitly.
  * [2f28ccc] Remove -ftrack-macro-expansion=0 option.

 -- Anton Gladky <gladk@debian.org>  Mon, 28 Oct 2013 20:55:21 +0100

yade (1.00.0-5) unstable; urgency=low

  * [b4d2aa3] Use clang on archs, where gcc fails. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Sat, 26 Oct 2013 22:25:21 +0200

yade (1.00.0-4) unstable; urgency=low

  * [91cd9f0] Set explicitly gcc-4.8 as the compiler for some archs. 
              Thanks to  Peter Green <plugwash@p10link.net>. (Closes: #726009)

 -- Anton Gladky <gladk@debian.org>  Thu, 24 Oct 2013 18:27:26 +0200

yade (1.00.0-3) unstable; urgency=low

  * [d386d37] Add libbz2-dev and zlib1g-dev to BD.
  * [dd8d977] Disable Release-Mode in Cmake, pass -ftrack-macro-expansion=0 to
              reduce RAM-consumption during compilation. (Closes: #726009)
  * [1942de7] Ignore quilt dir.
  * [de26aa7] Unapply patches after build.

 -- Anton Gladky <gladk@debian.org>  Tue, 15 Oct 2013 19:32:33 +0200

yade (1.00.0-2) unstable; urgency=low

  * [2b4cc97] Disable parallel build (fails due to RAM consumption).

 -- Anton Gladky <gladk@debian.org>  Tue, 01 Oct 2013 19:14:48 +0200

yade (1.00.0-1) unstable; urgency=low

  * [bbab763] Update debian/watch. Take version number from github.
  * [1c35234] Remove binutils-gold. (Closes: #722544)
  * [eb29103] Add BD for new PFV-feature.
  * [27ffe4a] Update break/replaces for older yade versions.
  * [6b2b68f] Remove mencoder from recommends.
  * [fe54741] Add system-component of boost to be linked.
  * [39b346a] Override lintian error (seems, false-positive).
  * [9edd741] Use canonical VCS-field.
  * [b3f639e] Imported Upstream version 1.00.0

 -- Anton Gladky <gladk@debian.org>  Mon, 30 Sep 2013 19:20:42 +0200

=== debian/control ===
Source: yade
Section: science
Priority: extra
Homepage: https://launchpad.net/yade
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Vcs-Git: git://anonscm.debian.org/debian-science/packages/yade.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/yade.git
X-Python-Version: current
Build-Depends:
 cmake,
 debhelper (>= 9),
 freeglut3-dev,
 help2man,
 ipython,
 libboost-all-dev,
 libbz2-dev,
 libcgal-dev [!armel],
 libeigen3-dev,
 libgl1-mesa-dev,
 libgts-dev,
 libloki-dev,
 libqglviewer-qt4-dev,
 libvtk5-dev,
 libxi-dev,
 libxmu-dev,
 pyqt4-dev-tools,
 python-all-dev (>= 2.6.6-3~),
 python-argparse,
 python-imaging,
 python-matplotlib,
 python-numpy,
 python-qt4,
 python-support,
 python-tk,
 python-xlib,
 zlib1g-dev
Build-Depends-Indep:
 dvipng,
 graphviz,
 libjs-jquery,
 lmodern,
 python-bibtex,
 python-sphinx (>= 1.0.7+dfsg),
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-latex-recommended,
 texlive-pictures,
 texlive-xetex,
 tipa
Standards-Version: 3.9.4

Package: yade
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: foreign
Depends:
 gnuplot,
 gtk2-engines-pixbuf,
 ipython,
 libyade (= ${binary:Version}),
 python-yade (= ${binary:Version}), 
 ${python:Depends},
 ${misc:Depends}
Description: Platform for discrete element modeling
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains speed-optimized build of yade.

Package: libyade
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: same
Breaks: yade (<<0.97.0-2) 
Replaces: yade (<<0.97.0-2) 
Depends:
 libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
 ${misc:Depends},
 ${shlibs:Depends}
Description: Platform for discrete element modeling. Libraries
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains yade`s libraries.

Package: python-yade
Architecture: any
Section: python
Pre-Depends:
 ${misc:Pre-Depends}
Multi-Arch: foreign
Breaks: yade (<<0.97.0-2) 
Replaces: yade (<<0.97.0-2) 
Depends:
 libyade (= ${binary:Version}),
 python-argparse,
 python-imaging,
 python-matplotlib,
 python-qt4,
 python-tk,
 python-xlib,
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Description: Platform for discrete element modeling. Python bindings
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains python bindings for yade.

Package: yade-doc
Architecture: all
Section: doc
Recommends:
 yade
Depends:
 ${sphinxdoc:Depends},
 ${misc:Depends}
Description: Platform for discrete element modeling. Documentation
 Yet Another Dynamic Engine.
 .
 Extensible open-source framework for discrete numerical models,
 focused on Discrete Element Method.
 The computation parts are written in c++ using flexible object model,
 allowing independent implementation of new algorithms and interfaces.
 Python is used for rapid and concise scene construction,
 simulation control, postprocessing and debugging.
 .
 This package contains examples, test scripts and documentation.

=== debian/rules ===
#!/usr/bin/make -f
BUILDDIR = $(CURDIR)/debian/build
tmpInstall = $(CURDIR)/debian/tmp
tmpDirMatplotLib = $(CURDIR)/debian/matplotlib

%:
	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory

export MPLCONFIGDIR := $(tmpDirMatplotLib) 
export HOME := $(tmpDirMatplotLib) 
export LD_LIBRARY_PATH :=  $(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/gts:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade:$(tmpInstall)/usr/lib/$(DEB_HOST_MULTIARCH)/yade/py/yade/qt:$(LD_LIBRARY_PATH); 
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export YADE_PREFIX := $(tmpInstall)/usr

extra_flags += \
-DruntimePREFIX="/usr" \
-DINSTALL_PREFIX="/usr" \
-DNOSUFFIX=ON \
-DLIBRARY_OUTPUT_PATH=lib/$(DEB_HOST_MULTIARCH) \

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)
	mkdir -p $(tmpDirMatplotLib)
	mkdir -p $(tmpInstall)
	#Output an information about available memory and CPU
	-cat /proc/meminfo
	-cat /proc/cpuinfo

override_dh_auto_install-arch:
	dh_auto_install -a
	# generate manpages
	help2man $(tmpInstall)/usr/bin/yade > yade.1
	help2man $(tmpInstall)/usr/bin/yade-batch > yade-batch.1
	$(tmpInstall)/usr/bin/yade --test
	$(tmpInstall)/usr/bin/yade --check
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f
	dh_numpy

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_installman:
	dh_installman -p yade yade.1 yade-batch.1

override_dh_compress:
	dh_compress --all -X.py -X.stl -X.gts -X.geo -X.mesh -X.msh -X.pdf -X.png -X.svg -X.txt -X.js -X.inv

override_dh_auto_install-indep: 
	#Generate docs
	cd $(CURDIR)/doc/sphinx; PYTHONPATH=. $(tmpInstall)/usr/bin/yade yadeSphinx.py; cd _build/latex; xelatex Yade.tex; xelatex Yade.tex; xelatex Yade.tex;
	#Delete all pyc files
	find . -name '*.pyc' -print0 | xargs -0 rm -f

override_dh_auto_test: 

override_dh_installdocs-indep:
	dh_installdocs
	dh_sphinxdoc

override_dh_auto_clean:
	dh_auto_clean
	rm -rf $(BUILDDIR)

## yade 1.07.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,25 +39,46 @@
 INCLUDE(FindPythonModule)
 INCLUDE(GNUInstallDirs)
 #===========================================================
+# HACK!!! If the version of gcc is 4.8 or greater, we add -ftrack-macro-expansion=0 
+# and -save-temps into compiler to reduce the memory consumption during compilation.
+# See http://bugs.debian.org/726009 for more information
+# Can be removed later, if gcc fixes its regression
+# Taken from http://stackoverflow.com/questions/4058565/check-gcc-minor-in-cmake
+ 
+EXECUTE_PROCESS(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
+IF (GCC_VERSION VERSION_GREATER 4.8 OR GCC_VERSION VERSION_EQUAL 4.8)
+  MESSAGE(STATUS "GCC Version >= 4.8. Adding -ftrack-macro-expansion=0 and -save-temps")
+  SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -ftrack-macro-expansion=0 -save-temps")
+ENDIF()
+
+#===========================================================
+
+IF ("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")
+  SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -ftemplate-depth-512")
+ENDIF()
+
+#===========================================================
+ADD_DEFINITIONS(" -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast ")
 IF (CMAKE_CXX_FLAGS)
   #If flags are set, add only neccessary flags
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG")
+    ADD_DEFINITIONS("-DYADE_DEBUG")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
-    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -fPIC")
+    SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fPIC")
   ENDIF (DEBUG)
 ELSE (CMAKE_CXX_FLAGS)
   #If flags are not set, add all useful flags
   IF (DEBUG)
     SET(CMAKE_VERBOSE_MAKEFILE 1)
     SET(CMAKE_BUILD_TYPE Debug)
-    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}  -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -DYADE_DEBUG -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
+    ADD_DEFINITIONS("-DYADE_DEBUG")
+    SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -Wall -fPIC -g -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security")
   ELSE (DEBUG)
     SET(CMAKE_BUILD_TYPE Release)
-    SET(CMAKE_CXX_FLAGS  "-DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast -Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
+    SET(CMAKE_CXX_FLAGS  "-Wall -fPIC -g -O2 -fstack-protector --param=ssp-buffer-size=4 -Wformat -Wformat-security -Werror=format-security -s")
   ENDIF (DEBUG)
 ENDIF (CMAKE_CXX_FLAGS)
 #===========================================================
@@ -109,7 +130,7 @@
 SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
 #===========================================================
 IF(ENABLE_VTK)
-  FIND_PACKAGE(VTK COMPONENTS Common) 
+  FIND_PACKAGE(VTK) 
   IF(VTK_FOUND)
     INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
     LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
@@ -244,7 +265,7 @@
     MESSAGE(STATUS "Found Metis")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} LinSolv")
   ELSE(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    MESSAGE(STATUS "CHOLMOD NOT found, LINSOLV disabled")
+    MESSAGE(STATUS "Missing dependency for LINSOLV, disabled")
     SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
     SET(ENABLE_LINSOLV OFF)
   ENDIF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
@@ -260,23 +281,3 @@
     SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
     MESSAGE(STATUS "Found GL2PS")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")
-  ELSE(GL2PS_FOUND)
-    MESSAGE(STATUS "GL2PS NOT found")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
-    SET(ENABLE_GL2PS OFF)
-  ENDIF(GL2PS_FOUND)
-ELSE(ENABLE_GL2PS)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} GL2PS")
-ENDIF(ENABLE_GL2PS)
-
-INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_DIRS})
-INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extra/floating_point_utilities_v3)
-INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})
-
-#===========================================================
-
-IF (NOT INSTALL_PREFIX)
- SET(CMAKE_INSTALL_PREFIX "/usr/local")
- MESSAGE("Yade will be installed to default path ${CMAKE_INSTALL_PREFIX}, if you want to override it use -DINSTALL_PREFIX option.")
-ELSE (NOT INSTALL_PREFIX)
-	GET_FILENAME_COMPONENT(CMAKE_INSTALL_PREFIX ${INSTALL_PREFIX} ABSOLUTE)

=== gui/CMakeLists.txt ===
IF(${ENABLE_GUI})
  INCLUDE(${QT_USE_FILE})
  INCLUDE_DIRECTORIES(${QGLVIEWER_INCLUDE_DIR})
  
  SET(_GLViewer_MOC_HEADERS qt4/GLViewer.hpp;qt4/OpenGLManager.hpp)
  SET(_GLViewer_SOURCE_FILES qt4/GLViewer.cpp;qt4/_GLViewer.cpp;qt4/OpenGLManager.cpp;qt4/GLViewerDisplay.cpp;qt4/GLViewerMouse.cpp)
  
  QT4_WRAP_CPP(_GLViewer_MOC_OUTFILES ${_GLViewer_MOC_HEADERS})
  
  ADD_LIBRARY(_GLViewer SHARED ${_GLViewer_SOURCE_FILES} ${_GLViewer_MOC_OUTFILES})
  SET_TARGET_PROPERTIES(_GLViewer PROPERTIES PREFIX "")
  TARGET_LINK_LIBRARIES(_GLViewer ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QT_LIBRARIES} ${QGLVIEWER_LIBRARIES} ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
  IF(GL2PS_FOUND AND ENABLE_GL2PS)
    TARGET_LINK_LIBRARIES(_GLViewer ${GL2PS_LIBRARIES})
  ENDIF(GL2PS_FOUND AND ENABLE_GL2PS)
  INSTALL(TARGETS _GLViewer DESTINATION ${YADE_PY_PATH}/yade/qt)
  
  FILE(GLOB filesPYQT "${CMAKE_CURRENT_SOURCE_DIR}/qt4/*.py")
  INSTALL(FILES ${filesPYQT} DESTINATION ${YADE_PY_PATH}/yade/qt)
  
  EXECUTE_PROCESS(
        COMMAND "pyrcc4" "-o" "${CMAKE_BINARY_DIR}/img_rc.py" "img.qrc"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
        RESULT_VARIABLE rv
        )
  
  EXECUTE_PROCESS(
        COMMAND "pyuic4" "-o" "${CMAKE_BINARY_DIR}/ui_controller.py" "controller.ui"
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/qt4
        RESULT_VARIABLE rv
        )
  INSTALL(FILES ${CMAKE_BINARY_DIR}/img_rc.py ${CMAKE_BINARY_DIR}/ui_controller.py  DESTINATION ${YADE_PY_PATH}/yade/qt)
  
ENDIF(${ENABLE_GUI})

=== py/CMakeLists.txt ===
#==================pygts=========================================
IF(ENABLE_GTS)
  find_python_module(gts)
  IF (PY_gts)
    MESSAGE(STATUS "Use system gts version")
  ELSE (PY_gts)
    MESSAGE(STATUS "Use embedded version of gts. Please, consider installing the corresponding package")
    FILE(GLOB SRC_PYGTS "${CMAKE_CURRENT_SOURCE_DIR}/3rd-party/pygts-0.3.1/*.c")
    ADD_LIBRARY(_gts SHARED ${SRC_PYGTS})
    SET_TARGET_PROPERTIES(_gts PROPERTIES PREFIX "")
    TARGET_LINK_LIBRARIES(_gts gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/__init__.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(FILES 3rd-party/pygts-0.3.1/pygts.py DESTINATION ${YADE_LIB_PATH}/py/gts)
    INSTALL(TARGETS _gts DESTINATION ${YADE_LIB_PATH}/py/gts)
  ENDIF (PY_gts)
ENDIF(ENABLE_GTS)
#==================pygts=========================================

#==================pyModules=========================================

FILE(GLOB filesPY "${CMAKE_CURRENT_SOURCE_DIR}/*.py")
SET(filesPY "${filesPY};${CMAKE_CURRENT_SOURCE_DIR}/pack/pack.py")
INSTALL(FILES ${filesPY} DESTINATION ${YADE_PY_PATH}/yade)
INSTALL(FILES 3rd-party/mtTkinter-0.3/mtTkinter.py DESTINATION ${YADE_LIB_PATH}/py)
FILE(GLOB filesPYTests "${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py")
INSTALL(FILES ${filesPYTests} DESTINATION ${YADE_PY_PATH}/yade/tests)
FILE(GLOB filesPYPerf "${CMAKE_CURRENT_SOURCE_DIR}/../examples/test/performance/*")
INSTALL(FILES ${filesPYPerf} DESTINATION ${YADE_PY_PATH}/yade/tests/checks/performance)
ADD_LIBRARY(WeightedAverage2d SHARED "${CMAKE_CURRENT_SOURCE_DIR}/WeightedAverage2d.cpp")
SET_TARGET_PROPERTIES(WeightedAverage2d PROPERTIES PREFIX "")
INSTALL(TARGETS WeightedAverage2d DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_utils.cpp")
SET_TARGET_PROPERTIES(_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_utils yade)
INSTALL(TARGETS _utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_polyhedra_utils SHARED "${CMAKE_CURRENT_SOURCE_DIR}/_polyhedra_utils.cpp")
SET_TARGET_PROPERTIES(_polyhedra_utils PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_polyhedra_utils)
INSTALL(TARGETS _polyhedra_utils DESTINATION "${YADE_PY_PATH}/yade/")


ADD_LIBRARY(_packPredicates SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packPredicates.cpp")
SET_TARGET_PROPERTIES(_packPredicates PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packPredicates yade)
IF(ENABLE_GTS AND NOT(PY_gts))
  TARGET_LINK_LIBRARIES(_packPredicates _gts)
ENDIF(ENABLE_GTS AND NOT(PY_gts))


INSTALL(TARGETS _packPredicates DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packSpheres SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packSpheres.cpp")
SET_TARGET_PROPERTIES(_packSpheres PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_packSpheres yade)
INSTALL(TARGETS _packSpheres DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_packObb SHARED "${CMAKE_CURRENT_SOURCE_DIR}/pack/_packObb.cpp")
SET_TARGET_PROPERTIES(_packObb PROPERTIES PREFIX "")
INSTALL(TARGETS _packObb DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(wrapper SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/yadeWrapper.cpp")
SET_TARGET_PROPERTIES(wrapper PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(wrapper yade)
INSTALL(TARGETS wrapper DESTINATION "${YADE_PY_PATH}/yade/")

ADD_LIBRARY(_customConverters SHARED "${CMAKE_CURRENT_SOURCE_DIR}/wrapper/customConverters.cpp")
SET_TARGET_PROPERTIES(_customConverters PROPERTIES PREFIX "")
TARGET_LINK_LIBRARIES(_customConverters yade)
INSTALL(TARGETS _customConverters DESTINATION "${YADE_PY_PATH}/yade/")

=== debian/changelog ===
yade (1.07.0-2) unstable; urgency=medium

  * [1de8256] Increase number of steps in checkWeight.py.

 -- Anton Gladky <gladk@debian.org>  Sun, 19 Jan 2014 19:59:34 +0100

yade (1.07.0-1) unstable; urgency=medium

  * [d42c7de] Imported Upstream version 1.07.0
  * [a421b10] Remove patch, applied by upstream.
  * [d151f88] Set Standards-Version: 3.9.5. No changes.
  * [a9616c6] Add upstream file.
  * [c078bb4] Inject additional parameters for weak archs. 
              Thanks to Roland Stigge <stigge@antcom.de>. (Closes: #733152)
  * [21a2430] Fix version definition for IPython>1.0.0.
  * [8204093] Remove google-scripts from documentation.

 -- Anton Gladky <gladk@debian.org>  Mon, 13 Jan 2014 20:13:14 +0100

=== debian/control ===
--- 
+++ 
@@ -20,15 +20,20 @@
  libgl1-mesa-dev,
  libgts-dev,
  libloki-dev,
- libqglviewer-qt4-dev,
+ libmetis-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libqglviewer-dev,
+ libsuitesparse-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
  libvtk5-dev,
  libxi-dev,
  libxmu-dev,
  pyqt4-dev-tools,
  python-all-dev (>= 2.6.6-3~),
  python-argparse,
+ python-gts,
  python-imaging,
  python-matplotlib,
+ python-minieigen [!s390],
  python-numpy,
  python-qt4,
  python-support,
@@ -48,7 +53,7 @@
  texlive-pictures,
  texlive-xetex,
  tipa
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 
 Package: yade
 Architecture: any
@@ -109,8 +114,10 @@
 Depends:
  libyade (= ${binary:Version}),
  python-argparse,
+ python-gts,
  python-imaging,
  python-matplotlib,
+ python-minieigen,
  python-qt4,
  python-tk,
  python-xlib,

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,11 @@
 	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory
+
+# Theses flags are neccessry for weak archs. See #733152
+ifneq (,$(filter $(DEB_HOST_ARCH), armel armhf hurd-i386 mips mipsel))
+	export DEB_CXXFLAGS_MAINT_APPEND = --param ggc-min-expand=20 --param ggc-min-heapsize=128000
+endif
 
 export MPLCONFIGDIR := $(tmpDirMatplotLib) 
 export HOME := $(tmpDirMatplotLib)

## yade 1.10.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,9 +14,13 @@
 #  ENABLE_GL2PS: enable GL2PS-option (ON by default)
 #  ENABLE_LINSOLV: enable LINSOLV-option (ON by default)
 #  ENABLE_PFVFLOW: enable PFVFLOW-option, FlowEngine (ON by default)
+#  ENABLE_SPH: enable SPH-option, Smoothed Particle Hydrodynamics (OFF by default, experimental)
+#  ENABLE_LBMFLOW: enable LBMFLOW-option, LBM_ENGINE (OFF by default)
+#  ENABLE_LIQMIGRATION: enable LIQMIGRATION-option, see [Mani2013] for details (OFF by default)
+#  ENABLE_MASK_ARBITRARY: enable MASK_ARBITRARY option (OFF by default)
 #  runtimePREFIX: used for packaging, when install directory is not the same is runtime directory (/usr/local by default)
 #  CHUNKSIZE: set >1, if you want several sources to be compiled at once. Increases compilation speed and RAM-consumption during it (1 by default).
-
+#  VECTORIZE: enables vectorization and alignment in Eigen3 library, experimental (OFF by default)
 
 project(Yade C CXX)
 cmake_minimum_required(VERSION 2.8)
@@ -58,7 +62,7 @@
 ENDIF()
 
 #===========================================================
-ADD_DEFINITIONS(" -DYADE_PTR_CAST=static_pointer_cast -DYADE_CAST=static_cast ")
+ADD_DEFINITIONS(" -DYADE_PTR_CAST=boost::static_pointer_cast -DYADE_CAST=static_cast ")
 IF (CMAKE_CXX_FLAGS)
   #If flags are set, add only neccessary flags
   IF (DEBUG)
@@ -84,7 +88,10 @@
 #===========================================================
 # Add possibility to use local boost installation (e.g. -DLocalBoost=1.46.1)
 
-FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread date_time filesystem iostreams regex serialization system REQUIRED)
+IF ( NOT LocalBoost )
+  SET(LocalBoost "1.35.0") # Minimal required Boost version
+ENDIF ( NOT LocalBoost )
+FIND_PACKAGE(Boost ${LocalBoost} COMPONENTS python thread filesystem iostreams regex serialization system date_time REQUIRED)
 INCLUDE_DIRECTORIES (${Boost_INCLUDE_DIRS})
 # for checking purpose
 MESSAGE("--   Boost_VERSION: " ${Boost_VERSION})
@@ -116,18 +123,46 @@
 OPTION(ENABLE_GL2PS "Enable GL2PS" ${DEFAULT})
 OPTION(ENABLE_LINSOLV "Enable direct solver for the flow engines (experimental)" ${DEFAULT})
 OPTION(ENABLE_PFVFLOW "Enable flow engine (experimental)" ${DEFAULT})
+OPTION(ENABLE_SPH "Enable SPH" OFF)
+OPTION(ENABLE_LBMFLOW "Enable LBM engine (very experimental)" OFF)
+OPTION(ENABLE_LIQMIGRATION "Enable liquid control (very experimental), see [Mani2013] for details" OFF)
+OPTION(ENABLE_MASK_ARBITRARY "Enable arbitrary precision of bitmask variables (only Body::groupMask yet implemented) (experimental). Use -DMASK_ARBITRARY_SIZE=int to set number of used bits (256 by default)" OFF)
 
 #===========================================================
 # Use Eigen3 by default
 IF (EIGEN3_FOUND)
   INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIR})
-  MESSAGE(STATUS "Found Eigen3")
+  MESSAGE(STATUS "Found Eigen3, version: ${EIGEN3_VERSION}")
+  
+  # Minimal recommended version 3.2.1
+  IF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))
+    MESSAGE(WARNING "Minimal recommended Eigen3 version is 3.2.1")
+  ENDIF ((${EIGEN3_MAJOR_VERSION} LESS 2) OR ((${EIGEN3_MAJOR_VERSION} EQUAL 2) AND (${EIGEN3_MINOR_VERSION} LESS 1)))
+
   SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Eigen3")
+  IF (NOT VECTORIZE)
+    MESSAGE(STATUS "Disable vectorization")
+    ADD_DEFINITIONS("-DEIGEN_DONT_VECTORIZE -DEIGEN_DONT_ALIGN -DEIGEN_DISABLE_UNALIGNED_ARRAY_ASSERT")
+  ELSE (NOT VECTORIZE)
+    MESSAGE(STATUS "Enable vectorization")
+  ENDIF (NOT VECTORIZE)
+  
 ENDIF(EIGEN3_FOUND)
 #===========================================================
 INCLUDE_DIRECTORIES(${BZIP2_INCLUDE_DIR})
 INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIRS})
 SET(LINKLIBS  "${LINKLIBS};${BZIP2_LIBRARIES};${ZLIB_LIBRARIES};")
+#===========================================================
+IF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+  ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
+  SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} Odeint")
+  ADD_DEFINITIONS("-DYADE_ODEINT")
+ELSE((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+    ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
+  SET(DISABLED_FEATS "${DISABLED_FEATS} Odeint")
+  MESSAGE(STATUS "Boost Odeint can be enabled, only if Boost>=1.53 is used")
+ENDIF((Boost_MAJOR_VERSION EQUAL 1) OR (Boost_MAJOR_VERSION GREATER 1) AND
+     ((Boost_MINOR_VERSION EQUAL 53) OR (Boost_MINOR_VERSION GREATER 53)))
 #===========================================================
 IF(ENABLE_VTK)
   FIND_PACKAGE(VTK) 
@@ -135,7 +170,6 @@
     INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
     LINK_DIRECTORIES( ${VTK_LIBRARY_DIRS} )
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_VTK")
-    SET(features "${features} vtk")
     MESSAGE(STATUS "Found VTK")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} VTK")
   ELSE(VTK_FOUND)
@@ -153,7 +187,6 @@
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENMP ${OpenMP_CXX_FLAGS}")
     MESSAGE(STATUS "Found OpenMP")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} OpenMP")
-    SET(features "${features} openmp")
   ELSE(OPENMP_FOUND)
     MESSAGE(STATUS "OpenMP NOT found")
     SET(ENABLE_OPENMP OFF)
@@ -173,7 +206,6 @@
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     MESSAGE(STATUS "Found GTS")
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GTS")
-    SET(features "${features} gts")
   ELSE(GTS_FOUND AND GLIB2_FOUND)
     MESSAGE(STATUS "GTS NOT found")
     SET(DISABLED_FEATS "${DISABLED_FEATS} GTS")
@@ -192,7 +224,6 @@
   IF(QT4_FOUND AND OPENGL_FOUND AND GLUT_FOUND AND GLIB2_FOUND AND QGLVIEWER_FOUND)
     SET(GUI_LIBS ${GLUT_LIBRARY} ${OPENGL_LIBRARY} ${QGLVIEWER_LIBRARIES})
     SET(GUI_SRC_LIB "lib/opengl/GLUtils.cpp")
-    SET(features "${features} qt4 opengl")
     SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_OPENGL")
     INCLUDE_DIRECTORIES(${GLIB2_INCLUDE_DIRS})
     INCLUDE_DIRECTORIES(${QT_INCLUDES})
@@ -232,52 +263,3 @@
     SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} CGAL")
 
     IF(ENABLE_PFVFLOW)
-      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DFLOW_ENGINE")
-      SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} PFVflow")
-    ELSE(ENABLE_PFVFLOW)
-      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
-    ENDIF(ENABLE_PFVFLOW)
-
-  ELSE(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
-    MESSAGE(STATUS "CGAL NOT found")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
-    SET(ENABLE_CGAL OFF)
-    IF(ENABLE_PFVFLOW)
-      SET(DISABLED_FEATS "${DISABLED_FEATS} PFVflow")
-      MESSAGE(STATUS "CGAL NOT found: PFVFLOW disabled")
-    ENDIF(ENABLE_PFVFLOW)
-
-  ENDIF(CGAL_FOUND AND GMP_FOUND AND (NOT("${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*clang")))
-ELSE(ENABLE_CGAL)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} CGAL")
-ENDIF(ENABLE_CGAL)
-#===========================================================
-IF(ENABLE_LINSOLV)
-  FIND_PACKAGE(Cholmod)
-  FIND_PACKAGE(OpenBlas)
-  FIND_PACKAGE(Metis)
-  IF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CGAL_DEFINITIONS} -DLINSOLV -DFLOW_ENGINE")
-    SET(LINKLIBS  "${LINKLIBS};${CHOLMOD_LIBRARIES};${AMD_LIBRARY};${CAMD_LIBRARY};${COLAMD_LIBRARY};${CCOLAMD_LIBRARY};${OPENBLAS_LIBRARY};${METIS_LIBRARY}")
-    INCLUDE_DIRECTORIES(${METIS_INCLUDE_DIR} ${CHOLMOD_INCLUDE_DIR})
-    MESSAGE(STATUS "Found Cholmod")
-    MESSAGE(STATUS "Found OpenBlas")
-    MESSAGE(STATUS "Found Metis")
-    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} LinSolv")
-  ELSE(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-    MESSAGE(STATUS "Missing dependency for LINSOLV, disabled")
-    SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
-    SET(ENABLE_LINSOLV OFF)
-  ENDIF(CHOLMOD_FOUND AND OPENBLAS_FOUND AND METIS_FOUND)
-ELSE(ENABLE_LINSOLV)
-  SET(DISABLED_FEATS "${DISABLED_FEATS} LinSolv")
-ENDIF(ENABLE_LINSOLV)
-#===============================================
-IF(ENABLE_GL2PS)
-  FIND_PACKAGE(GL2PS)
-  IF(GL2PS_FOUND)
-    INCLUDE_DIRECTORIES(${GL2PS_INCLUDE_DIR})
-    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DYADE_GL2PS")
-    SET(LINKLIBS  "${LINKLIBS};${GL2PS_LIBRARIES};")
-    MESSAGE(STATUS "Found GL2PS")
-    SET(CONFIGURED_FEATS "${CONFIGURED_FEATS} GL2PS")

=== debian/changelog ===
yade (1.10.0-1~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Remove python-gts, libmetis-dev, libopenblas-dev, libsuitesparse-dev and
    python-minieigen from Build-Depends.

 -- Anton Gladky <gladk@debian.org>  Fri, 11 Jul 2014 19:23:33 +0200

yade (1.10.0-1) unstable; urgency=medium

  * [431abb8] Imported Upstream version 1.10.0 (Closes: #750318)
  * [3552a3e] Set minimal vtk6 version 6.1.0+dfsg-8.
  * [cd915f6] Set minimal eigen3 version 3.2.1-2.
  * [8e02049] Add autopkgtest-field to control.
  * [38389f8] Remove patches aplied by upstream.

 -- Anton Gladky <gladk@debian.org>  Wed, 25 Jun 2014 20:43:49 +0200

yade (1.07.0-4~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.

 -- Anton Gladky <gladk@debian.org>  Thu, 10 Apr 2014 19:53:56 +0200

yade (1.07.0-4) unstable; urgency=medium

  * [053bf6f] Remove some build-depends, which were added to VTK6.
  * [a560cb6] Remove --parallel option. (Closes: #741827)
  * [1d1f0d5] Build yade only on amd64 hurd-i386 i386 
              kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32.
  * [fa8ee56] Add autotest.

 -- Anton Gladky <gladk@debian.org>  Sun, 30 Mar 2014 19:05:22 +0200

yade (1.07.0-3) unstable; urgency=medium

  * [c628d07] Update Depends for VTK6.
  * [2d27ac8] Fix compilation against new libqglviewer.
  * [3821427] Update date in debian/copyright.

 -- Anton Gladky <gladk@debian.org>  Sun, 16 Mar 2014 14:55:57 +0100

=== debian/control ===
--- 
+++ 
@@ -20,20 +20,15 @@
  libgl1-mesa-dev,
  libgts-dev,
  libloki-dev,
- libmetis-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
- libopenblas-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
- libqglviewer-dev,
- libsuitesparse-dev [amd64 i386 ia64 kfreebsd-amd64 kfreebsd-i386 powerpc],
+ libqglviewer-qt4-dev,
  libvtk5-dev,
  libxi-dev,
  libxmu-dev,
  pyqt4-dev-tools,
  python-all-dev (>= 2.6.6-3~),
  python-argparse,
- python-gts,
  python-imaging,
  python-matplotlib,
- python-minieigen [!s390],
  python-numpy,
  python-qt4,
  python-support,
@@ -54,9 +49,10 @@
  texlive-xetex,
  tipa
 Standards-Version: 3.9.5
+XS-Testsuite: autopkgtest
 
 Package: yade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32 
 Pre-Depends:
  ${misc:Pre-Depends}
 Multi-Arch: foreign
@@ -81,7 +77,7 @@
  This package contains speed-optimized build of yade.
 
 Package: libyade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32
 Pre-Depends:
  ${misc:Pre-Depends}
 Multi-Arch: same
@@ -104,7 +100,7 @@
  This package contains yade`s libraries.
 
 Package: python-yade
-Architecture: any
+Architecture: amd64 hurd-i386 i386 kfreebsd-amd64 kfreebsd-i386 powerpc s390x sparc ppc64 x32
 Section: python
 Pre-Depends:
  ${misc:Pre-Depends}
@@ -114,10 +110,8 @@
 Depends:
  libyade (= ${binary:Version}),
  python-argparse,
- python-gts,
  python-imaging,
  python-matplotlib,
- python-minieigen,
  python-qt4,
  python-tk,
  python-xlib,

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 tmpDirMatplotLib = $(CURDIR)/debian/matplotlib
 
 %:
-	dh $@ --buildsystem=cmake --builddirectory=$(BUILDDIR) --with python2
+	dh $@ --builddirectory=$(BUILDDIR) --with python2
 
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed,-no-keep-memory
